#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPX(op, t, x) operator op(CRP(t, x))
#define OPL(t, x) bool OPX(<, t, x) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef int64_t ll, i64;
typedef uint64_t ull, u64;
template <typename... Types>
using comtype = typename common_type<Types...>::type;
template <typename T>
using enable_if_arithmetic = typename enable_if<is_arithmetic<T>::value>::type;
template <typename T>
using enable_if_integral = typename enable_if<is_integral<T>::value>::type;
inline char getchar(int)
{
    static char buf[64 << 20], *S = buf, *T = buf;
    if (S == T) T = fread(S = buf, 1, 64 << 20, stdin) + buf;
    return S == T ? EOF : *S++;
}
template <typename T, typename = enable_if_integral<T>>
inline bool read(T &x)
{
    int ch = x = 0, f = 1;
    while (!isdigit(ch = getchar()))
        if (ch == EOF)
            return false;
        else if (ch == '-')
            f = 0;
    for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
    return x = f ? x : -x, true;
}
template <typename T, typename... Args, typename = enable_if_integral<T>>
inline bool read(T &x, Args &... args) { return read(x) && read(args...); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmin(CRP(T1, v1), CRP(T2, v2)) { return min<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmin(CRP(T, v), const Args &... args) { return min<TResult>(v, mmin(args...)); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmax(CRP(T1, v1), CRP(T2, v2)) { return max<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmax(CRP(T, v), const Args &... args) { return max<TResult>(v, mmax(args...)); }
inline ll gcd(ll a, ll b)
{
    for (; b; swap(a, b)) a %= b;
    return a;
}
inline ll fpow(ll a, ll b, ll m)
{
    ll r = 1;
    for (; b; b >>= 1, a = a * a % m)
        if (b & 1) r = r * a % m;
    return r;
}
constexpr double eps = 1e-8;
inline int sgn(double x) { return x > eps ? 1 : x < -eps ? -1 : 0; }
const int N = 1e5 + 50;
struct
{
    ll v[3];
} a[N];
map<ll, set<int>> M;
void ins(int x)
{
    M[a[x].v[0]].insert(x);
    M[a[x].v[1]].insert(x);
    M[a[x].v[2]].insert(x);
    M[a[x].v[0] << 32 | a[x].v[1]].insert(x);
    M[a[x].v[1] << 32 | a[x].v[2]].insert(x);
    M[a[x].v[0] << 32 | a[x].v[2]].insert(x);
}
void del(int x)
{
    M[a[x].v[0]].erase(x);
    M[a[x].v[1]].erase(x);
    M[a[x].v[2]].erase(x);
    M[a[x].v[0] << 32 | a[x].v[1]].erase(x);
    M[a[x].v[1] << 32 | a[x].v[2]].erase(x);
    M[a[x].v[0] << 32 | a[x].v[2]].erase(x);
}
int cnt[N];
int main()
{
    int n;
    read(n);
    for (int i = 2; i < n; i++) read(a[i].v[0], a[i].v[1], a[i].v[2]), sort(a[i].v, a[i].v + 3), ins(i);
    for (int i = 2; i < n; i++) cnt[a[i].v[0]]++, cnt[a[i].v[1]]++, cnt[a[i].v[2]]++;
    vector<ll> ans;
    ans.push_back(-1);
    for (int i = 1; i <= n; i++)
        if (cnt[i] == 1) ans[0] = i;
    int lasti = *M[ans[0]].begin();
    for (int i = 0; i < 3; i++)
        if (cnt[a[lasti].v[i]] == 2) ans.push_back(a[lasti].v[i]);
    for (int i = 2; i < n; i++)
    {
        ll prev1 = ans[i - 1], prev2 = ans[i - 2];
        if (prev1 > prev2) swap(prev1, prev2);
        lasti = *M[prev1 << 32 | prev2].begin();
        ans.push_back(a[lasti].v[0] + a[lasti].v[1] + a[lasti].v[2] - prev1 - prev2);
        del(lasti);
    }
    for (ll x : ans) printf("%lld ", x);
    return 0;
}